require 'pumpkin_modern'
include PumpkinModern

class Input
  define_key SDL::Key::ESCAPE, :exit
  define_key SDL::Key::LEFT,   :left
  define_key SDL::Key::RIGHT,  :right
  define_key SDL::Key::SPACE,  :jump
end

class BackGround < Task
  priority 0
  def render(i)
    i.screen.fill_rect(0, 0, 640, 480, [0,0,0])
  end
end

class Player < Task
  graphic :img_player, "image/noschar.bmp",
            :x => 0, :y => 0, :w => 32, :h => 32

  DY = -50
  AY = 4
  def initialize
    @x = 0
    @y = 400
    @jumping = false
    @dy = DY
    @ay = AY
  end

  def act(i)
    if i.key[:left]
      @x -= 8
    end
    if i.key[:right]
      @x += 8
    end
    if @jumping
      @y  += @dy
      @dy += @ay
      if @y > 400
        @y = 400
        # end jump
        @jumping = false
        @dy = DY
        @ay = AY
      end
    elsif i.key.pushed? :jump
      @jumping = true
    end

    #DebugMessage.puts(a)
  end

  def move_holizontal(i)
    loop do
      if i.key[:left]
        @x -= 8
      end
      if i.key[:right]
        @x += 8
      end
      Fiber.yield
    end
  end

  def move_jump(i)
    loop do
      if i.key.pushed?
        while @y <= 400
          @y  += @dy
          @dy += @ay
          Fiber.yield
        end
        @y = 400
      end
      Fiber.yield
    end
  end

  def render(i)
    i.screen.put(@@img_player, @x, @y)
  end
end

class Apple < Game
  def initialize(fullscreen = false)
    super
    Task.add BackGround.new
    Task.add Player.new
    Task.add DebugMessage.instance
    #DebugMessage.add_status{ Task.priorities}
  end
end

Apple.run
