module PumpkinModern
  class Game

    def self.run(fullscreen = false)
      new(fullscreen).run
    end

    def initialize(fullscreen)
      SDL.init( SDL::INIT_VIDEO|SDL::INIT_JOYSTICK|SDL::INIT_AUDIO ) 
      SDL::TTF.init
      SDL::Mixer.open

      if fullscreen
        @screen = SDL.set_video_mode( 640, 480, 16, SDL::SWSURFACE|SDL::FULLSCREEN )
        SDL::Mouse.hide
      else
        @screen = SDL.set_video_mode( 640, 480, 16, SDL::SWSURFACE )
      end

      @key = Input.new
      Task.info.key = @key
      Task.info.screen = @screen
    end

    def run
      timer = FPSTimerLight.new
      timer.reset
      #DebugMessage.add_status{ timer.real_fps.to_s }

      loop do
        @key.clear
        
        #poll
        @key.poll
        break if @key.info[:exit]

        #act
        Task.act

        #render
        timer.wait_frame do
          Task.render
          @screen.flip
        end
      end
    end

  end
end
